%{?mingw_package_header}

Name:           mingw-virt-viewer
Version:        7.0
Release:        1%{?dist}
Summary:        MinGW Windows virt-viewer console application

License:        GPLv2+
URL:            http://virt-manager.org/
Source0:        ftp://virt-manager.org/downloads/virt-viewer/virt-viewer-%{version}.tar.gz

BuildArch:      noarch
ExclusiveArch:  %{ix86} x86_64

BuildRequires:  mingw32-adwaita-icon-theme
BuildRequires:  mingw64-adwaita-icon-theme
BuildRequires:  mingw32-filesystem >= 95
BuildRequires:  mingw64-filesystem >= 95
BuildRequires:  mingw32-glib2 >= 2.22.0
BuildRequires:  mingw64-glib2 >= 2.22.0
BuildRequires:  mingw32-glib-networking
BuildRequires:  mingw64-glib-networking
BuildRequires:  mingw32-gstreamer1-plugins-bad-free
BuildRequires:  mingw64-gstreamer1-plugins-bad-free
BuildRequires:  mingw32-gstreamer1-plugins-good
BuildRequires:  mingw64-gstreamer1-plugins-good
BuildRequires:  mingw32-gtk-vnc2 >= 0.4.0
BuildRequires:  mingw64-gtk-vnc2 > 0.4.0
BuildRequires:  mingw32-gtk3 >= 3.0
BuildRequires:  mingw64-gtk3 >= 3.0
BuildRequires:  mingw32-libgovirt >= 0.3.2
BuildRequires:  mingw64-libgovirt >= 0.3.2
BuildRequires:  mingw32-libusbx >= 1.0.21
BuildRequires:  mingw64-libusbx >= 1.0.21
#BuildRequires:  mingw32-libvirt >= 0.10.0
#BuildRequires:  mingw64-libvirt >= 0.10.0
BuildRequires:  mingw32-libxml2 >= 2.6.0
BuildRequires:  mingw64-libxml2 >= 2.6.0
BuildRequires:  mingw32-openssl >= 1.0.1j
BuildRequires:  mingw64-openssl >= 1.0.1j
BuildRequires:  mingw32-readline
BuildRequires:  mingw64-readline
BuildRequires:  mingw32-rest
BuildRequires:  mingw64-rest
BuildRequires:  mingw32-spice-glib
BuildRequires:  mingw64-spice-glib
BuildRequires:  mingw32-spice-gtk3 >= 0.31-8
BuildRequires:  mingw64-spice-gtk3 >= 0.31-8
BuildRequires:  mingw32-usbredir
BuildRequires:  mingw64-usbredir
BuildRequires:  mingw32-celt051
BuildRequires:  mingw64-celt051
BuildRequires:  pkgconfig
BuildRequires:  /usr/bin/pod2man
BuildRequires:  intltool
BuildRequires:  icoutils
BuildRequires:  dos2unix
BuildRequires:  hwdata
BuildRequires:  unix2dos
BuildRequires:  msitools >= 0.93.93

BuildRequires:  hicolor-icon-theme
BuildRequires:  adwaita-icon-theme
BuildRequires:  intltool
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  libtool
BuildRequires:  glib2-devel

%description
MinGW Windows virt-viewer console application


%package -n mingw32-virt-viewer
Summary: %{summary}

%description -n mingw32-virt-viewer
MinGW Windows virt-viewer console application

%package -n mingw64-virt-viewer
Summary: %{summary}

%description -n mingw64-virt-viewer
MinGW Windows virt-viewer console application


%prep
%setup -q -n virt-viewer-%{version}

autoreconf -vfi

%build
# For z-stream before 1.0: Take the 1st and last digit and  v[0] << 4 + v[-1]
buildid=`echo %{release} | while IFS=. read -r -a entries; do  echo $(( ${entries[0]} * 16 + ( ${#entries[@]} > 2 ? ${entries[${#entries[@]} - 1]} : 0 ) )); done`

# Build for Win32
mkdir build_win32
pushd build_win32

%mingw32_configure                  \
    --with-gtk-vnc                  \
    --with-spice-gtk                \
    --with-gtk=3.0                  \
    --without-libvirt               \
    --with-ovirt                    \
    --with-osid="rhev-win32"        \
    --with-buildid=$buildid
%mingw32_make %{?_smp_mflags} V=1

popd

# Build for Win64
mkdir build_win64
pushd build_win64

%mingw64_configure                  \
    --with-gtk-vnc                  \
    --with-spice-gtk                \
    --with-gtk=3.0                  \
    --without-libvirt               \
    --with-ovirt                    \
    --with-osid="rhev-win64"        \
    --with-buildid=$buildid
%mingw64_make %{?_smp_mflags} V=1

popd


%install
rm -rf $RPM_BUILD_ROOT

pushd build_win32
%mingw32_make -C data msi
popd

pushd build_win64
%mingw64_make -C data msi
popd

mkdir -p $RPM_BUILD_ROOT%{mingw32_bindir}
mv "build_win32$MINGW_BUILDDIR_SUFFIX"/data/virt-viewer-x86-%{version}.msi $RPM_BUILD_ROOT%{mingw32_bindir}


mkdir -p $RPM_BUILD_ROOT%{mingw64_bindir}
mv "build_win64$MINGW_BUILDDIR_SUFFIX"/data/virt-viewer-x64-%{version}.msi $RPM_BUILD_ROOT%{mingw64_bindir}


%files -n mingw32-virt-viewer
%defattr(-,root,root)
%{mingw32_bindir}/virt-viewer-x86-%{version}.msi

%files -n mingw64-virt-viewer
%defattr(-,root,root)
%{mingw64_bindir}/virt-viewer-x64-%{version}.msi


%changelog
* Fri Aug 17 2018 Victor Toso <victortoso@redhat.com> - 7.0-1
- Update to Release 7.0
- ExclusiveArch: i686, x86_64
- Related to rhbz#1615874

* Mon Dec 11 2017 Victor Toso <victortoso@redhat.com> - 2.0-15
- Build to include the correct dependencies into the msi installer

* Thu Nov 30 2017 Victor Toso <victortoso@redhat.com> - 2.0-14
- Improve translations
  Resolves: rhbz#1292818

* Mon Dec 19 2016 Victor Toso <victortoso@redhat.com> - 2.0-13
- remove ImmDisableIME call without issues
  Resolves: rhbz#1342984

* Wed Dec  7 2016 Victor Toso <victortoso@redhat.com> - 2.0-12
- Fix redirect stdout/stderr messages to a file
  Resolves: rhbz#1373189

* Thu Jul 21 2016 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-11
- Add mnemonics for remote-viewer connection dialog
  Resolves: rhbz#1351501
- Adjust timer to refresh ovirt foreign menu
  Resolves: rhbz#1358809
- Avoid crash with invalid monitor config
  Related: rhbz#1343240

* Tue Jun 07 2016 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-10
- Remove nsis installer
  Related: rhbz#1324885 and rhbz#1316560
- Utilize SSO to authenticate against oVirt engine for foreign menu support
  Related: rhbz#1339247
- monitor-config: do it all or nothing
  Resolves: rhbz#1339499
- Return early on empty monitor mapping
  Resolves: rhbz#1339500
- Disable default grab sequence
  Resolves: rhbz#1342013
- Avoid crashing when using invalid video config
  Resolves: rhbz#1343240
- Add missing access keys
  Resolves: rhbz#1340906
- Add progress bar for file transfer
  Resolves: rhbz#1332180
- Depend on mingw-adwaita-icon-theme
  Resolves: rhbz#1301064
- Add DisableIME patch
  Resolves: rhbz#1297640

* Wed Apr 13 2016 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-9
- Update nettle and gnutls on nsis file due to CVEs issues
  Related: rhbz#1326052
- Get rid of mingw-libvirt dependency
- Fix nsis build when not building with libvirt support

* Sat Jan 02 2016 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-8
- Rebuild due to rhbz#1144043 fix in libusb and spice-gtk
  Related: rhbz#1144043

* Wed Nov 04 2015 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-7
- Use the display ID to configure fullscreen monitors
  Resolves: rhbz#1269918
- Disable extra displays in fullscreen mode
  Resolves: rhbz#1212802

* Thu Oct 22 2015 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-6
- Rebuild due to rhbz#1273977 fix in libgovirt
  Related: rhbz#1273977

* Tue Oct 20 2015 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-5
- Rebuild due to rhbz#1247927's fix in spice-gtk
  Related: rhbz#1247927

* Fri Oct  9 2015 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-4
- As spice-gtk is (again) built with smartcard support, update the nsis file adding the needed deps.
  Related: rhbz#1267386
- Fix .vv file association
  Related: rhbz#1146016

* Thu Jun 18 2015 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-3
- Remove fix for "missing .dll" problem as the problem was fixed in the right place (spice-gtk)
- Enable hotkeys after setting them in virt_viewer_app_set_hotkeys()
  Resolves: rhbz#1055600
- Allow to resize window to any size
  Resolves: rhbz#1205804

* Mon Jun 15 2015 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-2
- Fix "missing .dll" problem when opening remote-viewer with usbclerk/usbdk installed

* Wed Jun 10 2015 Fabiano Fidêncio <fidencio@redhat.com> - 2.0-1
- Rebase to virt-viewer 2.0
- Add patches used by rhel-7.2
- Add patches for version check
- Add patch for InstalLScope perMachine
- Add patch for missing dll of the ,exe file when building using --without-libvirt

* Sun Feb 08 2015 Uri Lublin <uril@redhat.com> - 0.6.0-2.2
- Set ALLUSERS in wxs file to do a proper perMachine install. rhbz#1187272
- Rebase mingw-openssl (1.0.1j-1)  to pick up CVE fixes. rhbz#1187585
- Rebase mingw-jasper (1.900.1-26) to pick up CVE fixes. rhbz#1188086 #1188087

* Tue Nov 18 2014 Uri Lublin <uril@redhat.com> - 0.6.0-2.1
- Do not open in fullscreen with CONTROLLER_AUTO_DISPLAY_RES. rhbz#1155764
- Pick spice-gtk to fix non-text clipboard. Fixes: rhbz#1161081

* Fri Aug 22 2014 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.6.0-2
- Pasting into java apps inserts unprintable character. Resolves: rhbz#1090122
- Fix various openssl flaws. rhbz#1128406

* Thu Jul 24 2014 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.6.0-1
- Rebase to 0.6.0. rhbz#1103366
- Fallback on ctrl+alt hotkey for ungrab. Resolves: rhbz#985319
- Always use auto-conf for fullscreen. Resolves: rhbz#1018145 rhbz#1076243
- Fix some auto-conf bugs. Resolves: rhbz#1018182 rhbz#1022608
- Fix some hang scenario with clipboard. Resolves: rhbz#1083489
- Fix gtk+ crash with invalid clipboard data. Resolves: rhbz#1090433
- Use a product version to fit -z releases. Resolves: rhbz#1105650
- Fix missing version hyphen in dialog. Resolves: rhbz#1115445

* Fri Jun  6 2014 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-25.3.4.1
- Set spice auto-conf when fullscreen is set in vv file. rhbz#1094340
- Take last spice-gtk & gtk builds. Related: rhbz#1083489
- Bump version to -25 to make it higher than 3.3

* Wed Apr 23 2014 Uri Lublin <uril@redhat.com> - 0.5.6-23
- Pick up mingw-openssl 1.0.1e-6.1 with a fix for CVE-2014-0160. rhbz#1085822

* Wed Apr 02 2014 Uri Lublin <uril@redhat.com> - 0.5.6-21
- Disconnect fullscreen map-event handler when leaving fullscreen. rhbz#1037662

* Wed Feb 26 2014 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-20
- Fix guest not resized on entering full-screen. rhbz#1069735

* Mon Feb 17 2014 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-19
- Sometimes, unable to copy&paste from Windows client. rhbz#1064939

* Tue Jan  7 2014 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-18
- Add missing "secure-attention" hotkey config, again. rhbz#1023447

* Tue Jan  7 2014 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-17
- Add missing "secure-attention" hotkey config. rhbz#1023447

* Thu Dec 19 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-16
- Add missing "secure-attention" hotkey config. rhbz#1023447

* Mon Nov 18 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-15
- Leave fullscreen on current window. rhbz#1017909

* Tue Nov 12 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-14
- Fix .vv file registration after msitools update.

* Tue Nov 12 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-13
- Fix MSI upgrade. rhbz#984136

* Mon Nov 11 2013 Jonathon Jongsma <jjongsma@redhat.com> - 0.5.6-12
- Allow higher-than-native resolution in fullscreen mode.  rhbz#1021618

* Fri Nov  8 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-11
- Fix MSI upgrade. rhbz#984136

* Thu Oct 31 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-10
- Too many windows open with fullscreen=auto-conf. rhbz#985898

* Tue Oct 29 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-9
- Too many windows open with fullscreen=auto-conf. rhbz#985898
- spice-gtk mono cursor fix. rhbz#1002697
- Try same fix as RHEL6 for rhbz#872288

* Thu Oct 17 2013 Jonathon Jongsma <jjongsma@redhat.com> - 0.5.6-8
- Enable ctrl+alt+del keybinding in fullscreen mode. rhbz#1004440

* Sun Oct 13 2013 Uri Lublin <uril@redhat.com> - 0.5.6-7
- NSIS installer - compare versions and install only if needed. rhbz#857038

* Wed Oct  2 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-6
- hotkeys: send modifiers before non-modifier keys. rhbz#846006
- Add keyboard binding to send CAD. rhbz#1004440
- Missing sqlite dll in MSI. rhbz#1014089

* Mon Sep  9 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-5
- Fix default window size when leaving fullscreen. rhbz#978362

* Sun Aug 25 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-4
- Rebuild for spice-gtk fixes:
- usb: request for driver uninstall only for driver that were installed. Related: rhbz#919166
- Add CRLF-LF conversion. Related: rhbz#1000125
- Pass the right ptr to destroy. Related: rhbz#997893

* Wed Aug 14 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-3
- Does not respect auto configuration of monitors. Resolves: rhbz#967154
- Two monitors are in fullscreen at only one screen. Resolves: rhbz#872288
- Do not restrict disabling display to != 0. Resolves: rhbz#958550
- Allow to fullscreen and position display independently. Resolves: rhbz#558241
- Auto-add Hot Key combos to "Send key" menu. Resolves: rhbz#846006

* Thu Jul 25 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-2
- Fix missing symbols, modules, icons and dlls.

* Fri Jul 5 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.6-1
- Rebase to upstream 0.5.6
- Build MSI installer

* Fri Apr 26 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-25
- Exit virt-viewer when trying to close any window. Resolves: rhbz#910634

* Tue Apr  9 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-24
- Maximize when leaving fullscreen first time. Resolves: rhbz#916810
- Fix second display disappears regressions rhbz#918997
  Resolves: rhbz#928855, rhbz#928850

* Wed Mar 27 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-23
- Reuse menu to avoid gtk+2 freeze bug
  Resovles: rhbz#927882
- Keep display size when leaving fullscreen for first time
  Resovles: rhbz#916810
- Fix changing guest resolution when started in fullscreen
  Resolves: rhbz#873298
- Fix snapped window being unsapped.
  Resolves: rhbz#912713
- Include spice-gtk fixes
  Related: rhbz#923894 #752483 #918342 #857114 #919530 #906560 #922818
- Include gtk+ utf8 conversion fix, related: rhbz#924006

* Thu Mar 14 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-22
- Fix spice-gtk libcacard

* Tue Mar 12 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-21
- nsis: add Spice smartcard (related: rhbz#866418)
- Fix monitors with same resolution, rhbz#913206
- Fix "unable to connect" dialog on VM shutdown, rhbz#913080

* Thu Feb 14 2013 Uri Lublin <uril@redhat.com> - 0.5.3-20
- nsis: silence usbclerk installer

* Thu Feb 14 2013 Marc-André Lureau  <marcandre.lureau@redhat.com> - 0.5.3-19
- Add a warning dialog when closing SPICE session back.

* Fri Feb  8 2013 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-18
- Updated to match with fixes from 6.4 0.5.2-18

* Thu Nov 15 2012 Uri Lublin <uril@redhat.com> - 0.5.3-17
- Related: rhbz#872640

* Mon Nov 05 2012 Uri Lublin <uril@redhat.com> - 0.5.3-16
- Rebuild to pick a new version of spicex-win (version bump)

* Fri Nov 02 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-15
- Rebuild to pick changes in mingw-spice-gtk
  Related: rhbz#857430
  Related: rhbz#857389
  Related: rhbz#871125
  Related: rhbz#871562

* Wed Oct 31 2012 Uri Lublin <uril@redhat.com> - 0.5.3-14
- Rebuild to pick changes in usbclerk-win and mingw-spice-gtk
  Related: rhbz#767581
  Related: rhbz#852392

* Tue Oct 30 2012 Christophe Fergeau <cfergeau@redhat.com> - 0.5.3-13
- Small fix to the patch for rhbz#861214 suggested by Uri
  Related: rhbz#861214

* Fri Oct 26 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-12
- Only pick spice-gtk = 0.12-7, since repo has newer version that we
  don t want yet
- Exit when controller is used and an invalid SPICE ticket is given
  Resolves: rhbz#861214
- Fix installer shouldn't proceed if already running
  Resolves: rhbz#864033

* Tue Aug  7 2012 Uri Lublin <uril@redhat.com> - 0.5.3-11
- Rebuild to pick up usbclerk with license files

* Tue Aug  7 2012 Uri Lublin <uril@redhat.com> - 0.5.3-10
- Updated License to GPLv2+

* Wed Aug  1 2012 Uri Lublin <uril.lureau@redhat.com> - 0.5.3-9
- Use usbclerk-setup to install usbclerk service

* Wed Jul 11 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-8
- Fix registration/unregistration of usbclerk service

* Wed Jul 11 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-7
- Ship with spice-gtk usbredir

* Fri Jun 29 2012  Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-5
- Ship and register Spice USB clerk

* Mon Jun 18 2012  Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-4
- Unregister ActiveX, and silently

* Sat Jun 16 2012  Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-3
- Ship ActiveX

* Tue Jun  5 2012  Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-2
- Fix spice migration, and activex uninstall
- Simplify build

* Mon May 14 2012 Marc-André Lureau <marcandre.lureau@redhat.com> - 0.5.3-1
- Initial packaging
